#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "carte.h"


/*!
* \file carte.c
* \brief Fichier contenant le code des fonctions liees aux cartes.
*/


/*!
 * \fn Carte* LireCarte(int num)
 * \brief La fonction recupere la n-ieme carte dans un fichier et renvoie un pointeur sur la carte cree
 *
 * \return Un pointeur sur une tableau de lettres.
 */
char* LireCarte(const char *filename, int num)
{
    char char_num_map[2],char_nb_lignes[2]="",char_nb_colonnes[2]="";
    int num_map = 0, nb_lignes = 0, nb_colonnes = 0, i=0, j=0, k=0;
    FILE* file_map = NULL;
    file_map = fopen(filename, "r");

    fseek(file_map, 3, SEEK_SET);
    (fgets(char_num_map,3,file_map));
    num_map = atoi(char_num_map);
    (fgets(char_nb_lignes,3,file_map));
    nb_lignes = atoi(char_nb_lignes);
    fseek(file_map, 1, SEEK_CUR);
    (fgets(char_nb_colonnes,3,file_map));
    nb_colonnes = atoi(char_nb_colonnes);

    while(num_map < num)
    {
        for(k=0; k<nb_colonnes+4; k++) /*! Descend jusqu' la prochaine map */
        {
            fseek(file_map,nb_lignes,SEEK_CUR);
        }
        fseek(file_map, 3, SEEK_CUR);
        (fgets(char_num_map,3,file_map));
        num_map = atoi(char_num_map);
        (fgets(char_nb_lignes,3,file_map));
        nb_lignes = atoi(char_nb_lignes);
        fseek(file_map, 1, SEEK_CUR);
        (fgets(char_nb_colonnes,3,file_map));
        nb_colonnes = atoi(char_nb_colonnes);
    }

    fseek(file_map, 4, SEEK_CUR);

    char * TableauCarte = NULL;
    TableauCarte = malloc(nb_colonnes * nb_lignes * sizeof(char));

    for(i=0; i<nb_colonnes; i++)
    {
        for(j=0; j<=nb_lignes; j++)
        {
            TableauCarte[nb_lignes*i+j]=fgetc(file_map);
        }
    }

    fclose(file_map);
    return TableauCarte;
}


